/*
 *  ngtk/test/vscroll.c
 *
 *  Copyright (C) 1998, 1999 Gabriel Fort <gabx@tfz.net>
 *
 */

/*----------------------------------------------------------------------------
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
----------------------------------------------------------------------------*/
#include <ngtk/ngtk.h>
#include "ngtk_test.h"

char *strings[27] = {
    "a", "bb", "ccc", "dddd", "eeeee", "ffffff", "ggggggg", "hhhhhhhh",
    "iiiiiiiii", "jjjjjjjjjj", "kkkkkkkkkkk", "llllllllllll", "mmmmmmmmmmmmm",
    "nnnnnnnnnnnnnn", "ooooooooooooooo", "pppppppppppppppp",
    "qqqqqqqqqqqqqqqqq", "rrrrrrrrrrrrrrrrrr", "sssssssssssssssssss",
    "tttttttttttttttttttt", "uuuuuuuuuuuuuuuuuuuuu",
    "vvvvvvvvvvvvvvvvvvvvvv", "wwwwwwwwwwwwwwwwwwwwwww",
    "xxxxxxxxxxxxxxxxxxxxxxxx", "yyyyyyyyyyyyyyyyyyyyyyyyy",
    "zzzzzzzzzzzzzzzzzzzzzzzzzz"
};

void cleanup_scroll_test(void)
{
	ngtk_topbar(BLACK_F(WHITE_B), A_NORMAL, version_info, 0);
}

void scroll_test(void)
{
    int buf;
    ngtk_scroll_t *foo;
	ngtk_win_t *box;

    ngtk_topbar(BLACK_F(WHITE_B), A_NORMAL, " Scrolling Test, press Esc to finish (I know, it looks ugly :(", 0);
    box = ngtk_mkbox(15, 22, 5, 10, WHITE_F(WHITE_B), A_BOLD, "Scrolling Test", \
					 0, 1, 0);
    foo = ngtk_mk_scroll_win(13, 20, 6, 11, WHITE_F(WHITE_B), A_BOLD, 0, 0, 26,
							 strings);

    ngtk_display_scroll_buffer(foo, 0);
    doupdate();

    while (1) {
		if (use_ngtk_main == 0)
			buf = ngtk_tty_getc();
		else
	        buf = ngtk_get_keysym();

        switch(buf) {
            case NGTK_KEY_DOWN:
                ngtk_scroll_line_down(foo);
				doupdate();
                break;

            case NGTK_KEY_UP:
                ngtk_scroll_line_up(foo);
				doupdate();
                break;

            case ESC:
                ngtk_pop_win(foo->container);
                ngtk_pop_win(box);
                ngtk_free_scroll_buffer(foo);
				cleanup_scroll_test();
                return;
                break;

            default:
                break;
        }
        doupdate();
    }
}

void init_scroll_test(void)
{
    ngtk_register_key(NGTK_KEY_F(6), scroll_test, "F6", "Scroll", 1);
}
